#include <iostream>
#include <map>
using namespace std;

struct data {
   uint group, age, scholarship;
   data( uint group = 0, uint age = 0, uint scholarship = 0 ) 
      : group( group ), age( age ), scholarship( scholarship ) {}
   data( const data& d ) : 
      group( d.group ), age( d.age ), scholarship( d.scholarship ) {}
   inline friend ostream& operator <<( ostream& out, const data& obj ) {
      return out << "[" << obj.group << " : " << obj.age 
                 << " : " << obj.scholarship << " ]";
   }  
};

typedef map< string, data > faculty;

int main( void ) { 
   faculty filology;
   filology.insert( pair< string, data >( "Сидоров С.С.", data( 13, 19, 1500 ) ) );
   filology.insert( pair< string, data >( "Иванов И.И.", data( 13, 20 ) ) );
   filology.insert( pair< string, data >( "Петров П.П.", data( 11, 21 ) ) );
   for( auto i = filology.begin(); i != filology.end(); i++ ) {
      cout << ( *i ).first << " : " << ( *i ).second << endl;
   }
   data d1( filology[ "Иванов И.И." ] );
   data d2 = filology[ "Иванов И.И." ];
   cout << d2 << endl;
}
