#include <iostream>
#include <sstream>
#include <map>
using namespace std;

int main( int argc, char **argv ) {
   map< char, unsigned > alphabet;
   cout << "alphabet size = " << alphabet.size() << endl;
   while( cin ) {
      string line;
      getline( cin, line );
      if( line.empty() ) continue;
      istringstream ist( line );
      char let;
      while( ( let = ist.get() ) &&
             !( ist.rdstate() & ios::eofbit ) ) {
         pair< map< char, unsigned >::iterator, bool > ret;
         ret = alphabet.insert( pair< char, unsigned >( let, 1 ) );
         if( !ret.second ) ret.first->second++;
      }
   }
   cout << "alphabet size = " << alphabet.size() << endl;
   for( char c = 'a'; c <= 'z'; c++ ) {
      cout << c << "(";
      try { cout << alphabet.at( c ); }
      catch( exception const& e ) { cout << '-'; }
      cout << ") ";
   }
   cout << endl;
   cout << "alphabet size = " << alphabet.size() << endl;
   for( char c = 'a'; c <= 'z'; c++ ) {
      cout << c << "(" << alphabet[ c ] << ") ";
   }
   cout << endl;
   cout << "alphabet size = " << alphabet.size() << endl;
}
