#include <iostream>
#include <map>
using namespace std;

template< typename Map > void print_map( Map& m ) {
   cout << "{ ";
   for( auto& p: m )
      cout << p.first << ':' << p.second << ' ';
   cout << "}" << endl;
}

bool great( int lhs, int rhs ) { return lhs > rhs; }

struct classcomp {
  bool operator()( const int& lhs, const int& rhs ) const {
     return lhs > rhs;
  }
};

int main( int argc, char **argv ) {
   map< int, int, less< int > > ml = {
      { 1, 2 }, { 2, 3 }, { 3, 4 }, { 4, 5 }
   };
   print_map( ml );
   map< int, int, bool(*)( int, int ) > mg1( great );
   mg1.insert( ml.begin(), ml.end() );
   print_map( mg1 );
   map< int, int, classcomp > mg3( ml.begin(), ml.end() );
   print_map( mg3 );
}


