#include <iostream>
#include <sstream>
#include <map>
using namespace std;

int main( int argc, char **argv ) {
   multimap< char, unsigned > alphabet;
   while( cin ) {
      string line;
      getline( cin, line );
      if( line.empty() ) continue;
      istringstream ist( line );
      char let;
      while( ( let = ist.get() ) &&
             !( ist.rdstate() & ios::eofbit ) )
         alphabet.insert( pair< char, unsigned >( let, 1 ) );
   }
   cout << "alphabet size = " << alphabet.size() << endl;
   for( char c = 'a'; c <= 'z'; c++ )
      cout << c << "(" << alphabet.count( c ) << ") ";
   cout << endl;
   alphabet.erase( 'a' );
   cout << "alphabet size = " << alphabet.size() << endl;
   for( char c = 'a'; c <= 'z'; c++ )
      cout << c << "(" << alphabet.count( c ) << ") ";
   cout << endl;
   cout << "alphabet size = " << alphabet.size() << endl;
}
