#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <cmath>
#include <set>
using namespace std;

int main( int argc, char **argv ) {
   unsigned lim = 30, n = argc > 1 ? atoi( argv[ 1 ] ) : lim;
   set<unsigned> rnd;
   for( unsigned i = 0; i < n; i++ ) {
      rnd.insert( (unsigned)nearbyint( (float)rand() / RAND_MAX * ( lim - 1 ) ) );
   }
   cout.fill( '0' );
   for( unsigned i = 0; i < lim; i++ ) {
      if( 1 == rnd.count( i ) ) cout << setw( 2 ) << i << " ";
      else cout << "-  ";
   }
   cout << endl;
   for( auto i = rnd.begin(); i != rnd.end(); i++ )
      cout << setw( 2 ) << *i << " ";
   cout << endl;
}
