#include <vector>
#include <cstring>
#include <iostream>
using namespace std;

struct trimatrix : vector< vector<double> > {
   trimatrix( uint n ) {
      while( n > 0 ) {
         vector<double> row( n );
         for( uint i = 0; i < n; i++ )
            row[ i ] = n - i;
         push_back( row );
         n--; 
      }
   }
};

inline ostream& operator <<( ostream& out, const trimatrix& obj ) {
   for( uint i = 0; i < obj.size(); i++ ) {
      for( uint j = 0; j < obj[ i ].size(); j++ )
         cout << obj[ i ][ j ] << " ";
      cout << endl;
   }
   return out;
}

int main( void ) { 
   cout << trimatrix( 4 );
}
